''******************************
''*  Altair Simulator v1.4     *
''*  (C) 2008 Michael Rychlik  *
''******************************

' v1.0 - 01 Oct 2007 - original version
' v1.1 - 09 Dec 2007 - No change just bump verion inline with other modules
' v1.2 - 09 Mar 2008 - No change, just bump version 
' v1.3 - 20 Mar 2008 - Added "Starting CPU" message
' v1.4 - 21 Mar 2008 - Added reg_base to parameter list for ios and cpu start
'                      This is to support break points and single steping of he cpu emulator
'
'
CON
  _clkmode = xtal1 + pll8x
  _xinfreq = 10_000_000

  '_CLKMODE = RCSLOW            'Set to internal slow clock
  '_CLKMODE = RCFAST            'Set to internal fast clock

VAR
'Parameter list for cpu, do not change order.
  long reg_base     'Address (in Prop RAM) to which registers are dumped
  long ram_base     'Address (in prop RAM) of the altair RAM
  long rom_base     'Address (in prop RAM) of the altair ROM
  long ios_ctl_addr 'Address (in prop RAM) of the altair I/O system contol interface

'8080 register file, DO NOT change the order of these or add anything in between   
  long b_reg 
  long c_reg
  long d_reg
  long e_reg
  long h_reg
  long l_reg
  long m_reg
  long a_reg
  long psw_reg
  long sp
  long pc



  
OBJ

  cpu : "altair_cpu"
  mem : "altair_mem"
  ios : "altair_ios"

PUB main : okay

  reg_base := @b_reg
  
  b_reg   := 0
  c_reg   := 0
  d_reg   := 0
  e_reg   := 0
  h_reg   := 0
  l_reg   := 0
  m_reg   := 0
  a_reg   := 0
  psw_reg := 0
  sp      := 0
  pc      := 0



  okay := mem.init
  ram_base := mem.get_ram_base
  rom_base := mem.get_rom_base
  
  okay := ios.start(@reg_base)
  ios_ctl_addr := ios.get_ctl_addr

  ios.str(string("Starting CPU...",13))
  
  okay := cpu.start(@reg_base)
                         
  repeat


                                